Bug 8493 - Перестал отдавать адреса?
: Перестал отдавать адреса?
Status: CLOSED FIXED
: Sisyphus
(All bugs in Sisyphus/dhcp-server)
: unstable
: all Linux
: P2 critical
Assigned To:
:
:
:
:
:
  Show dependency tree
 
Reported: 2005-11-14 21:11 by
Modified: 2007-09-20 02:29 (History)


Attachments


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2005-11-14 21:11:51
После обновления до 
dhcp-server-3.0.3-alt1.i586.rpm 
перестали загружаться тонкие клиенты, использующие Etherboot. 
Причём если загрузка через PXE, то адрес выдаётся, PXE грузится, а от 
etherboot запрос уже не проходит. 
Понять в чём причина не смог.
------- Comment #1 From 2005-11-14 21:34:00 -------
У меня есть только линуксовые dhcp-клиенты, больше ничего проверить не могу.
------- Comment #2 From 2005-11-18 01:47:20 -------
подтверждаю
при получении IP обычным клиентом в логах идет

Nov 17 17:33:09 gw-v22 dhcpd: DHCPDISCOVER from 00:30:18:64:86:f0 via eth1
Nov 17 17:33:09 gw-v22 dhcpd: DHCPOFFER on 192.168.7.130 to 00:30:18:64:86:f0
via eth1
Nov 17 17:33:09 gw-v22 dhcpd: DHCPREQUEST for 192.168.7.130 (192.168.7.254) from
00:30:18:64:86:f0 via eth1
Nov 17 17:33:09 gw-v22 dhcpd: DHCPACK on 192.168.7.130 to 00:30:18:64:86:f0 via eth1

при попытке получении IP после PXE
Nov 17 17:34:26 gw-v22 dhcpd: DHCPDISCOVER from 00:03:47:22:1a:b3 via eth1
Nov 17 17:34:26 gw-v22 dhcpd: DHCPOFFER on 192.168.7.116 to 00:03:47:22:1a:b3
via eth1
Nov 17 17:38:39 gw-v22 dhcpd: DHCPDISCOVER from 00:03:47:22:1a:b3 via eth1
Nov 17 17:38:39 gw-v22 dhcpd: DHCPOFFER on 192.168.7.116 to 00:03:47:22:1a:b3
via eth1
Nov 17 17:42:53 gw-v22 dhcpd: DHCPDISCOVER from 00:03:47:22:1a:b3 via eth1
Nov 17 17:42:53 gw-v22 dhcpd: DHCPOFFER on 192.168.7.116 to 00:03:47:22:1a:b3
via eth1
Nov 17 17:47:06 gw-v22 dhcpd: DHCPDISCOVER from 00:03:47:22:1a:b3 via eth1
Nov 17 17:47:06 gw-v22 dhcpd: DHCPOFFER on 192.168.7.116 to 00:03:47:22:1a:b3
via eth1
Nov 17 17:51:20 gw-v22 dhcpd: DHCPDISCOVER from 00:03:47:22:1a:b3 via eth1
Nov 17 17:51:20 gw-v22 dhcpd: DHCPOFFER on 192.168.7.116 to 00:03:47:22:1a:b3
via eth1
Nov 17 17:55:34 gw-v22 dhcpd: DHCPDISCOVER from 00:03:47:22:1a:b3 via eth1
...
и так в цикле
похоже PXE клиент не может принять то что ему предлагают по DHCPOFFER
(ругается кстати на каждый DHCPOFFER что якобы не дают ему IP) и не хочет
отзываться DHCPREQUEST-ом



------- Comment #3 From 2005-11-18 01:57:53 -------
Ну что я могу сказать...
Если вы готовы помочь с тестированием, то я могу попробовать собрать бета-версию
(dhcp-3.0.4b2).
------- Comment #4 From 2006-05-03 13:01:19 -------
Что-то до боли знакомое.......
------- Comment #5 From 2006-05-08 18:17:37 -------
Опубликован релиз dhcp-3.0.4, когда соберу, можете снова проверить.
------- Comment #6 From 2006-06-09 18:27:10 -------
Проверьте dhcp-server-3.0.4-alt1
------- Comment #7 From 2006-07-28 19:01:50 -------
# rpm -q dhcp-server 
dhcp-server-3.0.4-alt1 
 
То же самое.  
клиент не воспринимает в полученном IP-адрес и продолжает попытки 
------- Comment #8 From 2006-07-30 19:06:50 -------
Жаль.  Непонятно, чем ещё я могу вам помочь.
Попадалась ли вам какая-нибудь сборка dhcp >= 3.0.4, с которой клиенты работают?
------- Comment #9 From 2006-08-28 17:27:16 -------
(In reply to comment #8)
> Жаль.  Непонятно, чем ещё я могу вам помочь.
> Попадалась ли вам какая-нибудь сборка dhcp >= 3.0.4, с которой клиенты работают?
Похоже http://ftp.isc.org/isc/dhcp/dhcp-3.0.5rc1.tar.gz работает.
------- Comment #10 From 2006-08-29 00:18:13 -------
Хорошо, соберу новый dhcpd поскорее.
------- Comment #11 From 2006-09-05 02:41:14 -------
Виталий, попробуйте dhcp-3.0.5-alt0.2
------- Comment #12 From 2006-09-14 20:43:37 -------
Всё так же: 
# rpm -q dhcp-server 
dhcp-server-3.0.5-alt0.2 
 
Sep 14 20:41:34 server dhcpd: DHCPDISCOVER from 00:90:f5:38:8d:e0 via eth0 
Sep 14 20:41:35 server dhcpd: DHCPOFFER on 192.168.0.198 to 00:90:f5:38:8d:e0 
via eth0 
Sep 14 20:41:36 server dhcpd: DHCPDISCOVER from 00:90:f5:38:8d:e0 via eth0 
Sep 14 20:41:37 server dhcpd: DHCPOFFER on 192.168.0.197 to 00:90:f5:38:8d:e0 
via eth0 
Sep 14 20:41:40 server dhcpd: DHCPDISCOVER from 00:90:f5:38:8d:e0 via eth0 
Sep 14 20:41:41 server dhcpd: DHCPOFFER on 192.168.0.196 to 00:90:f5:38:8d:e0 
via eth0 
 
 
На всякий случай в качестве клиента попробовал не только rom-o-matic, но и PXE 
загрузчик от nVidia в максселектовском ноуте: NVIDIA Boot Agent 216.0513 
 
На всякий даже  
# iptables -L 
Chain INPUT (policy ACCEPT) 
target     prot opt source               destination 
 
Chain FORWARD (policy ACCEPT) 
target     prot opt source               destination 
 
Chain OUTPUT (policy ACCEPT) 
target     prot opt source               destination 
 
------- Comment #13 From 2006-09-14 22:39:29 -------
Нет, всё не так. 
С новым dhcp-server работает XPE-загрузчик, встроенный в BIOS'ы, 
и dhcp-client получает адреса. 
Но PXE bootstrap loader с http://rom-o-matic.net/5.4.2/ (например для 
via-rhine) 
не хочет получать адрес, выдаваемый ему dhcp-server'ом. 
Возможно неверные настройки сервера? 
Откатываюсь на 3.0.2-alt1 
------- Comment #14 From 2006-09-17 04:01:05 -------
Всё чудесатее и чудесатее, но по прежнему вне сферы моего влияния.
------- Comment #15 From 2007-02-22 14:47:14 -------
Проверил загрузкой ноутбука MaxSelect A3:

Feb 22 14:41:32 gate dhcpd: DHCPDISCOVER from 00:16:17:4e:04:43 via local
Feb 22 14:41:33 gate dhcpd: DHCPOFFER on 192.168.1.246 to 00:16:17:4e:04:43 via
local
Feb 22 14:41:36 gate dhcpd: DHCPDISCOVER from 00:16:17:4e:04:43 via local
Feb 22 14:41:37 gate dhcpd: DHCPOFFER on 192.168.1.245 to 00:16:17:4e:04:43 via
local
Feb 22 14:41:44 gate dhcpd: DHCPDISCOVER from 00:16:17:4e:04:43 via local
Feb 22 14:41:45 gate dhcpd: DHCPOFFER on 192.168.1.244 to 00:16:17:4e:04:43 via
local

После чего пишет "не могу получить файл". Как видим, он не смог IP получить.
dhcp-server-3.0.5-alt1
------- Comment #16 From 2007-02-23 11:59:47 -------
Это продолжалось до тех пор, пока я не добавил в /etc/dhcp/dhcpd.conf
filename "/r8169.zpxe";
Оказывается, этот параметр нужен уже на этапе DHCPOFFER. Предполагаю, что и
отсутствие каких-то других настроек может привести к игнорированию PXE-агентом
пакетов DHCPOFFER. Проверялось на 3.0.5-alt1 в Сизифе i586 и на 3.0.2-alt1 в
Мастере 2.4.
Кроме того, я скачал eb-5.4.2-eepro100.zpxe для другого ноутбука (для MaxSelect
такого загрузчика нет) и дошёл на нём до второй стадии: eepro100.zpxe
скачивается по tftp и запускается, после чего он снова, уже сам, получает IP по
DHCP и пытается скачать файл. Дальше я не настраивал, так что у меня он получал
опять eepro100.zpxe, и всё по новой =).
Вот мой конфиг dhcpd.conf:
ddns-update-style none;

subnet 192.168.1.0 netmask 255.255.255.0 {
        option routers                  192.168.1.2;
        option subnet-mask              255.255.255.0;

        option nis-domain               "domain.org";
        option domain-name              "domain.org";
        option domain-name-servers      192.168.1.1;

        range dynamic-bootp 192.168.1.128 192.168.1.254;
        default-lease-time 21600;
        max-lease-time 43200;

        filename "/eepro100.zpxe";
        next-server 192.168.1.2;
}
192.168.1.2 - сервер DHCP и TFTP
------- Comment #17 From 2007-02-23 12:05:24 -------
Описание PXE, может, кому пригодится:
http://en.wikipedia.org/wiki/Preboot_Execution_Environment
------- Comment #18 From 2007-02-23 17:30:39 -------
(In reply to comment #17)
> Описание PXE, может, кому пригодится:
Ну... вот ещё интересного из "мож пригодится" -- про загрузку из PXE не при
помощи tftp/nfs, а прямиком монтируя block device поверх iSCSI или AoE
(последние разработки Etherboot'чиков):
http://www.linux.com/print.pl?sid=07/02/06/1856237
------- Comment #19 From 2007-02-24 11:50:20 -------
Во первых для PXE указание filename является обязательным. Иначе PXE-клиенту
нет
смысла принимать IP.

Во вторых сейчас для PXE как и для Etherboot рекомендуется указать некоторые
магические строчки. В понедельник я постараюсь добыть свои конфиги с прошлой
работы. Если не сумею - схожу к клиенту, сниму оттуда.

2 mike: монтирование блочного девайса IMHO интересно только для blade с NAS или
SAN. Но насколько я знаю лезвия обычно сами умеют грузиться с NAS или SAN.
------- Comment #20 From 2007-03-09 22:29:45 -------
Пытался опять. Обновил dhcp-server. История прежняя - Etherboot получает 
адрес, PXE - нет.
Строки в конфиге такие:
    group {
        filename "/eb-5.4.2-via-rhine.zpxe";
        host epia {
            hardware ethernet     00:40:63:C8:B7:02;
            fixed-address 192.168.0.3;
            if substring (option vendor-class-identifier, 0, 9) = "Etherboot" 
{
                    filename "vmlinuz-epia";
            } else {
                    filename "/eb-5.4.2-via-rhine.zpxe";
            }
        }
    }
------- Comment #21 From 2007-03-10 00:49:55 -------
А next-server есть?
------- Comment #22 From 2007-03-10 10:40:36 -------
Нет
------- Comment #23 From 2007-03-10 13:53:24 -------
А если указать? =) Это должен быть адрес TFTP-сервера.
------- Comment #24 From 2007-03-12 22:26:45 -------
Указал next-server, всё заработало. Спасибо, Григорий!
Хотя так и не понял особой важности явного указания этого параметра и такого 
неявного его требования...

# rpm -q dhcp-server
dhcp-server-3.0.5-alt1